<template>
  <div v-loading="loading">
    <div class="white-box">
      <el-tabs v-model="filterStatus" @tab-click="handleFilterStatusClick">
        <el-tab-pane label="全部" name="-1" :lazy="true"></el-tab-pane>
        <el-tab-pane label="待审核" name="0" :lazy="true"></el-tab-pane>
        <el-tab-pane label="审核通过" name="1" :lazy="true"></el-tab-pane>
        <el-tab-pane label="审核拒绝" name="3" :lazy="true"></el-tab-pane>
      </el-tabs>
      <div class="filter-box">
        <filter-user ref="filterUser" :filter-types="filterTypes" @select-value="handleFilterUser"></filter-user>
      </div>
      <el-table :data="tableData" stripe style="width: 100%;" @selection-change="handleSelectionChange"
                v-loading="loading" :height="tool.getTableHeight(true)">
        <el-table-column type="selection" width="55" v-if="tableHeaders"></el-table-column>
        <el-table-column v-for="(tableHeader, key) in tableHeaders" :key="key" :label="tableHeader.header" :width="tableHeader.other.width ? tableHeader.other.width : ''">
          <template slot-scope="scope">
            <template v-if="scope.row[tableHeader.index].other.tag" >
              <el-tag :type="scope.row[tableHeader.index].other.tag.type ? scope.row[tableHeader.index].other.tag.type : null" :size="scope.row[tableHeader.index].other.tag.size ? scope.row[tableHeader.index].other.tag.size : null" :class="scope.row[tableHeader.index].other.tag.class ? scope.row[tableHeader.index].other.tag.class : null" >{{scope.row[tableHeader.index].value}}</el-tag>
            </template>
            <template v-else-if="scope.row[tableHeader.index].other.progress" >
              <el-progress type="circle" :percentage="Number.parseInt(percentList['MOVE_PERCENT'][scope.row.ID])"
                           :width="50"
                           :stroke-width="3"></el-progress>
            </template>
            <template v-else>
              <div v-html="scope.row[tableHeader.index].value"></div>
            </template>
          </template>
        </el-table-column>
        <el-table-column fixed="right" label="操作" width="180" v-if="tableHeaders">
          <template slot-scope="scope" v-if="scope.row.AUDIT_STATUS==0">
            <el-dropdown size="small" trigger="click" v-show="permission.hasPermission(`reconsume/change-audit-pass`)||permission.hasPermission(`reconsume/change-audit`)">
              <el-button type="primary" size="small" @click.stop="">
                操作该数据<i class="el-icon-arrow-down el-icon--right"></i>
              </el-button>
              <el-dropdown-menu slot="dropdown">
                <el-dropdown-item command="pass" @click.native="handleAuditShow(scope.row)" v-show="permission.hasPermission(`reconsume/change-audit-pass`)">审核通过</el-dropdown-item>
                <el-dropdown-item command="refuse" @click.native="handleAudit(scope.row, 'reject')" v-show="permission.hasPermission(`reconsume/change-audit`)">审核拒绝</el-dropdown-item>
                <el-dropdown-item command="del" @click.native="handleDel(scope.row.ID)"
                                  v-show="permission.hasPermission(`reconsume/change-audit-delete`)">删除数据
                </el-dropdown-item>
              </el-dropdown-menu>
            </el-dropdown>
          </template>
        </el-table-column>
      </el-table>
      <div class="white-box-footer">
        <el-dropdown size="small" trigger="click" @command="handleMuli" v-if="(filterStatus==='0') && (permission.hasPermission(`reconsume/change-audit`)||permission.hasPermission(`reconsume/change-audit-delete`))">
          <el-button type="primary" size="small">
            所选数据<i class="el-icon-arrow-down el-icon--right"></i>
          </el-button>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item command="pass" v-if="permission.hasPermission(`reconsume/change-audit`)">批量审核</el-dropdown-item>
            <el-dropdown-item command="reject" v-if="permission.hasPermission(`reconsume/change-audit`)">批量拒审</el-dropdown-item>
            <el-dropdown-item command="del" @click.native="handleDel()" v-if="permission.hasPermission(`reconsume/change-audit-delete`)">批量删除</el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
        <el-button type="primary" size="small" @click="handleAdd" icon="el-icon-plus" v-show="permission.hasPermission(`reconsume/change-audit-add`)">申请变动复销</el-button>
        <el-button type="success" size="small" @click="handleExport"
                   v-show="permission.hasPermission(`reconsume/change-audit-list-export`)">导出Excel
        </el-button>
        <pagination :total="totalCount" :page_size="pageSize" @size-change="handleSizeChange" @current-change="handleCurrentChange"></pagination>
      </div>
      <el-dialog title="修改注册信息" :visible.sync="dialogEditFormVisible">
        <el-form ref="form" :model="form" label-width="250px" class="form-dialog" v-loading="dialogEditLoading">
          <el-form-item label="会员编号">
            <el-input v-model="form.baseInfo.USER_NAME" :disabled="true"></el-input>
          </el-form-item>
          <el-form-item label="会员姓名">
            <el-input v-model="form.baseInfo.REAL_NAME" :disabled="true"></el-input>
          </el-form-item>
          <el-form-item label="调整类型">
            <el-select v-model="form.type" placeholder="调整类型" @change="handleChangeType">
              <el-option label="调整积分余额" value="0" key="0"></el-option>
              <el-option label="调整剩余月数" value="1" key="1"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="调整积分" v-if="form.type==='0'">
            <el-input v-model="form.changePv"></el-input>
            <template>
              <el-tag type="success">可用余额：{{form.balance.unusedPV}}PV</el-tag>
            </template>
          </el-form-item>
          <el-form-item label="调整月数" v-if="form.type==='1'">
            <el-input v-model="form.changeMonth"></el-input>
            <template>
              <el-tag type="success">可用月数：{{form.balance.unusedMonth}}</el-tag>
            </template>
          </el-form-item>
          <el-form-item label="备注">
            <el-input type="textarea" :rows="2" placeholder="备注" v-model="form.remark">
            </el-input>
          </el-form-item>
          <el-form-item label="备注前台显示">
            <el-switch v-model="form.isShow" active-value="1" inactive-value="0">
            </el-switch>
          </el-form-item>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button @click="dialogEditFormVisible = false">取 消</el-button>
          <el-button type="primary" @click.native="handleEdit">修 改</el-button>
        </div>
      </el-dialog>
      <el-dialog title="审核余额调整" :visible.sync="dialogAuditFormVisible">
        <el-form :model="form" label-width="250px" class="form-dialog" v-loading="dialogAuditLoading">
          <el-form-item label="会员编号">
            <el-input v-model="form.baseInfo.USER_NAME" :disabled="true"></el-input>
          </el-form-item>
          <el-form-item label="会员姓名">
            <el-input v-model="form.baseInfo.REAL_NAME" :disabled="true"></el-input>
          </el-form-item>
          <el-form-item label="调整类型">
            <el-select v-model="form.type" placeholder="调整类型" @change="handleChangeType">
              <el-option label="调整积分余额" value="0" key="0"></el-option>
              <el-option label="调整剩余月数" value="1" key="1"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="调整积分" v-if="form.type==='0'">
            <el-input v-model="form.changePv"></el-input>
            <template>
              <el-tag type="success">可用余额：{{form.balance.unusedPV}}PV</el-tag>
            </template>
          </el-form-item>
          <el-form-item label="调整月数" v-if="form.type==='1'">
            <el-input v-model="form.changeMonth"></el-input>
            <template>
              <el-tag type="success">可用月数：{{form.balance.unusedMonth}}</el-tag>
            </template>
          </el-form-item>
          <el-form-item label="备注前台显示">
            <el-switch v-model="form.isShow" active-value="1" inactive-value="0">
            </el-switch>
          </el-form-item>
          <el-form-item label="备注">
            <el-input type="textarea" :rows="2" placeholder="备注" v-model="form.remark">
            </el-input>
          </el-form-item>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button @click="dialogAuditFormVisible = false">取 消</el-button>
          <el-button type="primary" @click.native="handleAuditPass">通 过</el-button>
        </div>
      </el-dialog>
    </div>
  </div>
</template>

<script>
  import network from '@/utils/network'
  import tool from '@/utils/tool'
  import FilterUser from '@/components/FilterUser'
  import baseInfo from '@/utils/baseInfo'
  import permission from '@/utils/permission'
  import Pagination from '@/components/Pagination'
  import filterHelper from '../../utils/filterHelper'

  export default {
    name: 'reconsume_change-audit-list',
    components: {FilterUser,Pagination},
    mounted() {
      this.getData()
    },
    data() {
      return {
        tableHeaders: null,
        allData: null,
        tableData: null,
        loading: true,
        multipleSelection: [],
        currentPage: 1,
        totalPages: 1,
        totalCount: 1,
        pageSize: 20,
        tool: tool,
        permission: permission,
        filterTypes: {},
        filterModel: {},
        filterStatus: '0',
        baseInfo: baseInfo,
        dialogEditLoading: false,
        dialogAuditLoading: false,
        dialogEditFormVisible: false,
        dialogAuditFormVisible: false,
        auditId: null,
        form: {
          id: null,
          baseInfo: {USER_NAME: null},
          balance: {
            unusedPV: 0,
            unusedMonth: 0,
          },
          type: '',
          changeAmount: null,
          changePv: null,
          changeMonth: null,
          remark: null,
          isShow: null,
          auditStatus: null
        },
      }
    },
    methods: {
      handleMuli(command) {
        if (this.multipleSelection.length < 1) {
          this.$message({
            message: '请选择要操作的记录',
            type: 'warning'
          })
          return;
        }
        if (command === 'pass') {
          this.handleAudit(null, 'true')
        } else if (command === 'reject') {
          this.handleAudit(null, 'reject')
        }
      },
      handleChangeType() {
        if (this.form.type === '0') {
          //this.form.changeAmount = this.form.changePv
        } else if (this.form.type === '1') {
          //this.form.changeAmount = this.form.changeMonth
        }
      },
      handleSelectionChange(val) {
        this.multipleSelection = val
      },
      handleCurrentChange(page) {
        this.getData(page, this.pageSize)
      },
      handleSizeChange(pageSize) {
        this.getData(this.currentPage, pageSize)
      },
      handleAdd() {
        this.$router.push({path: `/reconsume/change-audit-add`})
      },
      handleEditShow(row) {
        this.dialogEditLoading = true
        this.auditId = row.ID
        this.dialogEditFormVisible = true
        let vueObj = this
        network.getData('reconsume/change-audit-get', {id: this.auditId}).then(response => {
          vueObj.dialogEditLoading = false
          vueObj.form = response
          vueObj.form.type = String(response.type)
          vueObj.handleChangeType()
        })
      },
      handleEdit() {
        this.dialogEditFormVisible = false
        this.$message({
          message: '正在修改数据',
          type: 'info'
        })
        let path = 'reconsume/change-audit-edit'
        network.postData(path, this.form).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
          this.getData(this.currentPage, this.pageSize)
        }).catch(response => {
        })
      },
      handleAuditShow(row) {
        this.dialogAuditLoading = true
        this.auditId = row.ID
        this.dialogAuditFormVisible = true
        let vueObj = this
        network.getData('reconsume/change-audit-get', {id: this.auditId}).then(response => {
          vueObj.dialogAuditLoading = false
          vueObj.form = response
          vueObj.form.type = String(response.type)
          vueObj.form.createRemark = response.remark
          vueObj.handleChangeType()
        })
      },
      handleAuditPass() {
        this.dialogAuditFormVisible = false
        this.$message({
          message: '正在通过审核',
          type: 'info'
        })
        this.form.auditStatus = 'true'
        if (this.form.type === '0') {
          this.form.changeAmount = this.form.changePv
        } else if (this.form.type === '1') {
          this.form.changeAmount = this.form.changeMonth
        }
        let path = 'reconsume/change-audit-pass'
        network.postData(path, this.form).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
          this.getData(this.currentPage, this.pageSize)
        }).catch(response => {
        })
      },
      handleAudit(row = null, status) {
        let obj = this
        let title = '确定要通过审核？'
        if (status === 'reject') {
          title = '确定要拒绝审核？'
        }
        this.$prompt(title, '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          //type: 'warning',
          //inputType: 'textarea',
        }).then(({value}) => {
          let selectedIds = []
          if (row === null) {
            for (let val of obj.multipleSelection) {
              selectedIds.push(val.ID)
            }
          } else {
            selectedIds.push(row.ID)
          }
          return network.postData(`reconsume/change-audit`, {
            selected: selectedIds,
            remark: value,
            auditStatus: status
          })
        }).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
          this.getData(this.currentPage, this.pageSize)
        }).catch(response => {

        })
      },
      handleDel(id = null) {
        let obj = this
        this.$confirm('确定删除选定的数据？', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          let selectedIds = []
          if (id === null) {
            for (let val of obj.multipleSelection) {
              selectedIds.push(val.ID)
            }
          } else {
            selectedIds.push(id)
          }
          return network.postData(`reconsume/change-audit-delete`, {
            selected: selectedIds
          })
        }).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
          obj.getData(obj.currentPage, obj.pageSize)
        }).catch(response => {

        })
      },
      handleFilterStatusClick(tab, event) {
        filterHelper.clearFilterOption(this)
        this.getData()
      },
      handleFilterUser(filterData) {
        filterHelper.handleFilterUser(this, filterData)
      },
      getData(page, pageSize) {
        let filterData = this.filterModel
        let vueObj=this
        filterData.filterStatus = this.filterStatus != -1 ? `=,${this.filterStatus}` : ''
        network.getPageData(this, 'reconsume/change-audit-list', page, pageSize, filterData, function (response) {
          vueObj.allData = response
          vueObj.filterTypes = response.filterTypes
        })
      },
      handleExport(){
        this.$confirm(`确定要导出当前数据吗？`, '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          return network.getData(`reconsume/change-audit-list-export`, this.filterModel)
        }).then(response => {
          this.$message({
            message: response,
            type: 'success'
          })
        }).catch(response => {

        })
      },
    },
  }
</script>

<style scoped>

</style>